"use strict";

var blacklist = ['covershut.com', 'searchednews.com', 'fansshare.com', 'musicnow.cz', 'images-na.ssl-images-amazon.com', 'selcdn.ru'];

var currentResult = -1;//removed in windows version
var cachedAlbumArtist;//removed in windows version
var cachedTitle;//removed in windows version
var titleSearchUsed


var currentRequest = 0;
var cachedArtist;
var cachedAlbum;
//var wasClosed = true;

var rGoogle;
var rBing;
var tryGoogle = true;
var tryBing = true;
var useWhiteList = false;
var usingCustomPhrase = false;
var aR = new Array();
var aResult = new Array();
var reswlnum = 0;
var whitelist = new Array("grooveshark.com", "coveralia.com", "jazz.com", "bandzone.cz", "7digital.com", "7static.com", "ecover.to", "deejay.de", "deezer.com", "discogs.com", "djshop.de", "ebreggae.com", "eclassical.com", "textalk.se",
    "esenshop.com", "hitparade.ch", "hmv.ca", "chartstats.com", "itunes.apple.com", "juno.co.uk", "kalahari.com", "audioscrobbler.com", "maniadb.com", "mndigital.com", "mega-media.nl", "metal-archives.com",
    "metallibrary.ru", "nuclearblast.de", "psyshop.com", "qobuz.com", "revhq.com", "musique.sfr.fr", "soundstation.dk", "takealot.com", "theorchard.com", "vgmdb.net", "wantitall.co.za", "yesasia.com", "uulyrics.com");

function WebRequest() {
    this.host = '';
    this.name = '';
    this.className = '';
    this.onSuccess = null;
    this.onFailure = null;
}

function ImageResult() {
    this.imglink = '';
    this.height = '';
    this.width = '';
    this.thumblink = '';
}

var downloadPromise = null;





//var registerClosed = function () {
//    wasClosed = false;
//    if (!window.qUnit) {
//        window.localListen(thisWindow, 'closed', function () {
//            wasClosed = true;
//            if (downloadPromise) {
//                downloadPromise.cancel();
//            }
//            downloadPromise = null;
//            currentRequest = 0;
//            cachedArtist = undefined;
//            cachedTitle = undefined;
//        });
//    }
//};

//function NotifyWebReq(str) {
//    NotifyDebug('NotifyWebReq: ' + str);
//    searchTools.readWebPageAsync(str).then1((Content) => {
//        if ((Content) && (Content != ''))
//            LoadedWebPage(Content);
//        else
//            LoadWebPageFailed();
//    });
//    /*
//        var headers = newStringList();
//        headers.add('User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2840.99 Safari/537.36');
//
//        if (downloadPromise)
//            downloadPromise.cancel();
//        downloadPromise = app.utils.web.getURLContentAsync(str, {
//            headers: headers
//        });
//        downloadPromise.then(function (Content) {
//            downloadPromise = null;
//            if ((Content) && (Content != ''))
//                LoadedWebPage(Content);
//            else
//                LoadWebPageFailed();
//        }, function () {
//            LoadWebPageFailed();
//        });
//    */
//}
//
//function NotifyResult(res) {
//    searchTools.interfaces.aaSearch.showResult(res.imglink, res.thumblink, res.width, res.height, res.thumbwidth, res.thumbheight);
//    //res.thumblink
//    //res.width + 'x' + res.height
//}
//
//function NotifyDebug(str) {
//    ODS('aaSearch.js: ' + str);
//}
//
//function NotifyEnd() {
//    if (searchTools.interfaces.aaSearch.endSearch)
//        searchTools.interfaces.aaSearch.endSearch();
//}


function NotifyWebReq(str) {

   // window.external.notify('1' + str);
    window.android.request(str);
}

function NotifyResult(res) {
//    window.external.notify('2' + res.imglink);
//    window.external.notify('3' + res.thumblink);
//    window.external.notify('4' + res.width + 'x' + res.height);
    window.android.result(res.imglink, res.thumblink,  res.width,  res.height);
}

function NotifyDebug(str) {

   // window.external.notify('9' + 'JS: ' + str);
    window.android.debug("Debug: "+str);
}


function NotifyEnd() {
    //window.external.notify('8');
    window.android.onFinished(""+titleSearchUsed);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var rNextGoogle = function () {
    NotifyDebug('rNextGoogle');
    whatNext();
}
var rNextBing = function () {
    NotifyDebug('rNextBing');
    whatNext();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var searchSend = function (r, a, t) {
//    if (window._cleanUpCalled || wasClosed)
//        return;
    NotifyDebug('SearchSend');
    var site = r.className;
    var host;
    if (usingCustomPhrase)
        host = r.host.replace('%custom%', encodeURIComponent(a));
    else {
        var q = '';
        if (r.usingQuotation)
            q = '"';
        var artistList = a.split(';'); // can be more than one
        var astr = '';
        artistList.forEach(function (artist) {
            if (astr)
                astr += q + '%20' + q;
            astr += encodeURIComponent(artist);
        });

        host = r.host.replace('%artist%', astr).replace('%album%', encodeURIComponent(t));
    }
    //        host = encodeURI(host).replace('%2526', '%26');
    try {
        NotifyWebReq(host);
    } catch (err) {}
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var whatNext = function (init) {
//    if (window._cleanUpCalled || wasClosed)
//        return;
    var a;
    var t;
    a = cachedArtist;
    if (usingCustomPhrase) {
        t = '';
    } else {
        t = cachedAlbum;
    }
    if (init) {
        NotifyDebug('whatNext init');
    } else {
        NotifyDebug('whatNext continue');
        currentRequest++;
    }
    if (currentRequest < aR.length) {
        NotifyDebug('Calling search send');
        searchSend(aR[currentRequest], a, t);
    } else
        NotifyEnd();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var AddResult = function (res) {
    NotifyDebug('AddResult'+res);
    var iswl = false;
    if (useWhiteList) {
        for (var i = 0; whitelist[i]; i++) {
            if (res.imglink.search(whitelist[i]) != -1) {
                iswl = true;
                break;
            }
        }
    }
    if (iswl) {
        aResult.splice(reswlnum, 0, res);
        reswlnum++;
    } else {
        for (var i = 0; blacklist[i]; i++) {
            if (res.imglink.search(blacklist[i]) != -1) {
                NotifyDebug('AddResult - blaclisted ' + blacklist[i]);
                return;
            }
        }
        aResult.push(res);
    }
    NotifyDebug('AddResult END');
}
var rSuccessGoogle = function (html) {
    NotifyDebug('rSuccessGoogle');
    var googleRes = searchTools.parseGoogleImgSearchResponse(html);
    for (var i = 0; i < googleRes.length; i++) {
        AddResult(googleRes[i]);
    }
    if (aResult.length > 0) {
        for (var i = 0; i < aResult.length; i++) {
            NotifyResult(aResult[i]);
        }
        NotifyEnd();
        aResult.length = 0;
    } else
        whatNext();
}
var rSuccessBing = function (html) {
    NotifyDebug('rSuccessBing');
    var bingRes = searchTools.parseBingImgSearchResponse(html);
    for (var i = 0; i < bingRes.length; i++) {
        AddResult(bingRes[i]);
    }
    if (aResult.length > 0) {
        for (var i = 0; i < aResult.length; i++) {
            NotifyResult(aResult[i]);
        }
        NotifyEnd();
        aResult.length = 0;
    } else
        whatNext();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var init = function () {
    NotifyDebug('init');
    aResult.length = 0;
    aR.length = 0;
    reswlnum = 0;
    currentRequest = 0;
    if (tryGoogle) {
        if (usingCustomPhrase) {
            rGoogle = new WebRequest();
            rGoogle.onSuccess = rSuccessGoogle;
            rGoogle.onFailure = rNextGoogle;
            rGoogle.host = 'https://www.google.com/search?safe=active&tbs=iar:s,ift:jpg&q=%custom%&tbm=isch';
            rGoogle.sendString = '';
            rGoogle.name = 'Google';
            rGoogle.className = 'Google';
            aR.push(rGoogle);
        } else {
            rGoogle = new WebRequest();
            rGoogle.onSuccess = rSuccessGoogle;
            rGoogle.onFailure = rNextGoogle;
            rGoogle.host = 'https://www.google.com/search?safe=active&tbs=iar:s,ift:jpg&q="%artist%"+"%album%"&tbm=isch';
            rGoogle.sendString = '';
            rGoogle.name = 'Google';
            rGoogle.className = 'Google';
            rGoogle.usingQuotation = true;
            aR.push(rGoogle);

            // second request - try without quotation marks
            rGoogle = new WebRequest();
            rGoogle.onSuccess = rSuccessGoogle;
            rGoogle.onFailure = rNextGoogle;
            rGoogle.host = 'https://www.google.com/search?safe=active&tbs=iar:s,ift:jpg&q=%artist%+%album%&tbm=isch';
            rGoogle.sendString = '';
            rGoogle.name = 'Google';
            rGoogle.className = 'Google';
            rGoogle.usingQuotation = false;
            aR.push(rGoogle);
        }
    }

    if (tryBing) {
        if (usingCustomPhrase) {
            rBing = new WebRequest();
            rBing.onSuccess = rSuccessBing;
            rBing.onFailure = rNextBing;
            rBing.host = 'https://www.bing.com/images/search?q=%custom%&qft=+filterui:aspect-square&form=IRFLTR&first=1&tsc=ImageBasicHover&sc=1-100';
            rBing.sendString = '';
            rBing.name = 'Bing';
            rBing.className = 'Bing';
            aR.push(rBing);
        } else {
            /* do not use quotations marks, it seems it often ruins the result, as Bing is somehow ignoring the phrases and looks for only some words
            rBing = new WebRequest();
            rBing.onSuccess = rSuccessBing;
            rBing.onFailure = rNextBing;
            rBing.host = 'https://www.bing.com/images/search?q="%artist%"+"%album%"&qft=+filterui:aspect-square&form=IRFLTR&first=1&tsc=ImageBasicHover&sc=1-100';
            rBing.sendString = '';
            rBing.name = 'Bing';
            rBing.className = 'Bing';
            rBing.usingQuotation = true;
            aR.push(rBing);
*/
            // without quotation marks
            rBing = new WebRequest();
            rBing.onSuccess = rSuccessBing;
            rBing.onFailure = rNextBing;
            rBing.host = 'https://www.bing.com/images/search?q=%artist%+%album%&qft=+filterui:aspect-square&form=IRFLTR&first=1&tsc=ImageBasicHover&sc=1-100';
            rBing.sendString = '';
            rBing.name = 'Bing';
            rBing.className = 'Bing';
            rBing.usingQuotation = false;
            aR.push(rBing);
        }
    }
    whatNext(true);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//searchTools.interfaces.aaSearch.startSearch = function (artist, title) {
//    if (wasClosed) {
//        registerClosed();
//    }
//    NotifyDebug('SearchAA: Artist: ' + artist + ' ,Album: ' + title);
//    cachedArtist = artist || ''; // to avoid undefined value
//    cachedAlbum = title || '';
//    usingCustomPhrase = false;
//    init();
//}
//searchTools.interfaces.aaSearch.startCustomSearch = function (searchPhrase) {
//    if (wasClosed) {
//        registerClosed();
//    }
//    NotifyDebug('SearchAA: ' + searchPhrase);
//    cachedArtist = searchPhrase;
//    usingCustomPhrase = true;
//    init();
//}
//searchTools.interfaces.aaSearch.defaultSearchPhrase = function (artist, title) {
//    var retval = ''
//    if (artist)
//        retval = '"' + artist + '"';
//    if (title) {
//        if (retval)
//            retval += '+';
//        retval += '"' + title + '"';
//    }
//    return retval;
//}
//var LoadedWebPage = function (webcontent) {
//    NotifyDebug('LoadedWebPage');
//    if ((currentRequest < aR.length) && (aR[currentRequest].onSuccess != null)) {
//        aR[currentRequest].onSuccess(webcontent);
//    }
//}
//var LoadWebPageFailed = function () {
//    if (window._cleanUpCalled || wasClosed)
//        return;
//    NotifyDebug('LoadWebPageFailed');
//    if ((currentRequest < aR.length) && (aR[currentRequest].onFailure != null)) {
//        aR[currentRequest].onFailure();
//    }
//}


//MMA /////////////////////////////////////////////////////////

function noParenthesis(str) {
    // LS: eliminate parenthesis, it mostly includes featuring artists etc. , see mantis #13047 for details
    var res = str;
    if (str.indexOf('(') >= 0)
        res = str.substring(0, str.indexOf('('));
    if (str.indexOf('{') >= 0)
        res = str.substring(0, str.indexOf('{'));
    if (str.indexOf('[') >= 0)
        res = str.substring(0, str.indexOf('['));
    return res;
};

var SearchAA = function (albumArtist, artist, album, title) {
    NotifyDebug('SearchAA: Album Artist: '+albumArtist+' ,Artist: '+artist+' ,Album: '+album+' ,Title: '+title+' ,currentResult = '+currentResult);

    cachedAlbumArtist = noParenthesis( albumArtist);
    cachedArtist = noParenthesis( artist);
    cachedAlbum = noParenthesis( album);
    cachedTitle = noParenthesis( title);
    usingCustomPhrase = false;
    init();
    currentResult++; // so that next time another image is used
    //return lastResult;
}



var LoadedWebPage = function (webcontent) {
    NotifyDebug('LoadedWebPage');
    if ((currentRequest < aR.length) && (aR[currentRequest].onSuccess != null)) {
        aR[currentRequest].onSuccess(webcontent);
    }
}
var LoadWebPageFailed = function () {
    NotifyDebug('LoadWebPageFailed');
    if ((currentRequest < aR.length) && (aR[currentRequest].onFailure != null)) {
        aR[currentRequest].onFailure();
    }
}


var calculatePercent = function(part, total){
    NotifyDebug('calculatePercent: ' + part + ' total '+total);
    if (part <= 0){
        return 0;
    }
    return part/total
}
